﻿Public Class Form1
    Dim lngBUF As Integer
    Dim lngRET As Integer
    Dim bytBUF() As Byte
    Dim bytRET() As Byte
    Sub BYTE_CMP()
        Dim lngSIZ As Integer
        Dim lngCNT As Integer
        Dim bolCHK As Boolean

        ProgressBar1.Maximum = UBound(bytBUF)

        Try
            lngRET = &HA
            lngBUF = &H36

            'BMPファイルの&H36からの内容をCNSファイルの&H0Aに圧縮コピー
            Do
                Select Case True
                    Case UBound(bytBUF) < lngBUF
                        Exit Do
                    Case SAME_CHECK1()
                        lngCNT = 0
                        bolCHK = False
                    Case SAME_CHECK2()
                        lngCNT = 0
                        bolCHK = False
                    Case Else
                        If Not bolCHK Or lngCNT >= 255 Then
                            lngCNT = 0
                            bolCHK = True
                            lngSIZ = lngRET
                            lngRET = lngRET + 2
                        End If
                        lngCNT = lngCNT + 1
                        Call SetNUM(bytRET, lngSIZ, lngCNT \ 256 + &H60)
                        Call SetNUM(bytRET, lngSIZ + 1, lngCNT Mod 256)
                        Call SetNUM(bytRET, lngRET, bytBUF(lngBUF))
                        lngRET = lngRET + 1
                End Select

                lngBUF = lngBUF + 1
                If lngBUF <= ProgressBar1.Maximum Then
                    ProgressBar1.Value = lngBUF
                End If
                Application.DoEvents()
            Loop

        Catch ex As Exception
            Call MessageBox.Show(ex.Message)
            End
        End Try
    End Sub
    Function SAME_CHECK1() As Boolean
        Dim lngPOS As Integer
        Dim lngCNT As Integer
        Dim lngBEF As Integer
        Dim bolCHK As Boolean

        Try
            lngBEF = lngBUF - CLng("&HFFFF")
            If lngBEF < &H36 Then lngBEF = &H36
            For lngPOS = lngBEF To lngBUF - 3
                For lngCNT = 0 To 7
                    If UBound(bytBUF) < lngBUF + lngCNT Then Exit For
                    If bytBUF(lngPOS + lngCNT) <> bytBUF(lngBUF + lngCNT) Then Exit For
                Next lngCNT
                If lngCNT > 7 Then
                    bolCHK = True
                    Exit For
                End If
            Next lngPOS

            If Not bolCHK Then Exit Function

            For lngCNT = 0 To &HFF
                If UBound(bytBUF) < lngBUF + lngCNT Then Exit For
                If bytBUF(lngPOS + lngCNT) <> bytBUF(lngBUF + lngCNT) Then Exit For
            Next lngCNT
            Call SetNUM(bytRET, lngRET, lngCNT \ 256 + &H30)
            Call SetNUM(bytRET, lngRET + 1, lngCNT Mod 256)
            Call SetNUM(bytRET, lngRET + 2, (lngBUF - lngPOS) Mod 256)
            Call SetNUM(bytRET, lngRET + 3, (lngBUF - lngPOS) \ 256)
            lngBUF = lngBUF + lngCNT - 1
            lngRET = lngRET + 4
            Return True
        Catch ex As Exception
            Call MessageBox.Show(ex.Message)
            End
        End Try

    End Function
    Function SAME_CHECK2() As Boolean
        Dim lngPOS As Integer
        Dim bytCNT As Byte
        Dim lngBEF As Integer
        Dim bolCHK As Boolean

        Try
            lngBEF = lngBUF - 255
            If lngBEF < &H36 Then lngBEF = &H36
            For lngPOS = lngBEF To lngBUF - 1
                For bytCNT = 0 To 4
                    If UBound(bytBUF) < lngBUF + bytCNT Then Exit For
                    If bytBUF(lngPOS + bytCNT) <> bytBUF(lngBUF + bytCNT) Then Exit For
                Next bytCNT
                If bytCNT > 4 Then
                    bolCHK = True
                    Exit For
                End If
            Next lngPOS

            If Not bolCHK Then Exit Function

            For bytCNT = 0 To 14
                If UBound(bytBUF) < lngBUF + bytCNT Then Exit For
                If bytBUF(lngPOS + bytCNT) <> bytBUF(lngBUF + bytCNT) Then Exit For
            Next bytCNT
            Call SetNUM(bytRET, lngRET, bytCNT - 2)
            Call SetNUM(bytRET, lngRET + 1, lngBUF - lngPOS)
            lngBUF = lngBUF + bytCNT - 1
            lngRET = lngRET + 2
            Return True
        Catch ex As Exception
            Call MessageBox.Show(ex.Message)
            End
        End Try
    End Function
    Private Function GetNUM(ByVal bytWRK() As Byte, ByVal lngIDX As Integer) As Integer
        Try
            Return bytWRK(lngIDX)
        Catch exERR As Exception
            Return -1
        End Try
    End Function
    Private Sub SetNUM(ByRef bytWRK() As Byte, ByVal lngIDX As Integer, ByVal bytVAL As Byte)
        If UBound(bytWRK) < lngIDX Then ReDim Preserve bytWRK(lngIDX)
        bytWRK(lngIDX) = bytVAL
    End Sub
    Private Function Get16BitRGB(ByVal R As Integer, ByVal G As Integer, ByVal B As Integer) As Integer
        Return R / (255 / 31) * 2048 + G / (255 / 63) * 32 + B / (255 / 31)
    End Function
    Private Function バイナリ読込(ByVal strNAM As String, ByRef bytBUF() As Byte) As Boolean
        Dim objFS As System.IO.FileStream
        Dim lngIDX As Integer
        Dim lngMAX As Integer
        Try
            objFS = New System.IO.FileStream(strNAM, IO.FileMode.Open, IO.FileAccess.Read)
            lngMAX = objFS.Length - 1
            ReDim bytBUF(lngMAX)
            For lngIDX = 0 To lngMAX
                bytBUF(lngIDX) = objFS.ReadByte()
            Next
            objFS.Close()
            Return True
        Catch exERR As Exception
            Return False
        End Try
    End Function
    Private Function バイナリ書込(ByVal strNAM As String, ByVal bytBUF() As Byte, Optional ByVal lngPOS As Integer = 0) As Boolean
        Dim objFS As System.IO.FileStream
        Dim lngMDE As System.IO.FileMode
        If lngPOS = 0 Then
            lngMDE = IO.FileMode.Create
        Else
            lngMDE = IO.FileMode.Open 'Append
        End If
        Try
            objFS = New System.IO.FileStream(strNAM, lngMDE, System.IO.FileAccess.Write)
            If lngPOS > 0 Then objFS.Position = lngPOS 'objFS.Seek(lngPOS, IO.SeekOrigin.Begin)
            objFS.Write(bytBUF, 0, bytBUF.Length)
            objFS.Close()
            Return True
        Catch exERR As Exception
            Return False
        End Try
    End Function
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim strFLE As String
        Dim lngMAX As Integer

        ProgressBar1.Value = 0
        Label2.Text = ""
        Try

            strFLE = TextBox1.Text

            lngMAX = FileLen(strFLE) - 1

            ReDim bytBUF(lngMAX)
            ReDim bytRET(9)

            If Not バイナリ読込(strFLE, bytBUF) Then
                Call MessageBox.Show("画像ファイルが見つかりません")
                Exit Sub
            End If

            strFLE = Mid(strFLE, 1, Len(strFLE) - 4)
            If Dir(strFLE) <> "" Then
                If MessageBox.Show("CNSファイルが既に存在します。" & vbCrLf & "上書きしてもいいですか？", "確認", MessageBoxButtons.YesNo, MessageBoxIcon.Question) = Windows.Forms.DialogResult.Yes Then
                    Kill(strFLE)
                Else
                    Label2.Text = "CNSファイルが既に存在します"
                    Exit Sub
                End If
            End If

            'ヘッダの圧縮情報
            bytRET(0) = &H60
            bytRET(1) = &H8
            bytRET(2) = 0
            bytRET(3) = 0
            bytRET(4) = bytBUF(&H12)
            bytRET(5) = bytBUF(&H13)
            bytRET(6) = bytBUF(&H16)
            bytRET(7) = bytBUF(&H17)
            bytRET(8) = CByte("&H" & TextBox2.Text)  '設定内容不明のため適当な値を設定
            bytRET(9) = CByte("&H" & TextBox3.Text)

            Call BYTE_CMP()

            Call バイナリ書込(strFLE, bytRET)
            Label2.Text = "処理が終了しました"

        Catch ex As Exception
            Call MessageBox.Show(ex.Message)
        End Try
    End Sub
    Private Sub TextBox1_DragDrop(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles TextBox1.DragDrop
        Dim FilePath() As String

        'ドラッグしているファイル／フォルダの取得
        FilePath = CType(e.Data.GetData(DataFormats.FileDrop), String())

        'ファイルパスをに表示する　
        If FilePath.Length - 1 < 0 Then Return
        TextBox1.Text = FilePath(0)
    End Sub
    Private Sub TextBox1_DragEnter(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles TextBox1.DragEnter
        'データ形式の確認
        If e.Data.GetDataPresent(DataFormats.FileDrop) = False Then Return

        'ドラッグしているファイル／フォルダの取得
        Dim FilePath() As String
        FilePath = CType(e.Data.GetData(DataFormats.FileDrop), String())

        If FilePath.Length - 1 < 0 Then Return
        If Not System.IO.File.Exists(FilePath(0)) Then Return

        'ドロップ可能な場合は、エフェクトを変える
        e.Effect = DragDropEffects.Copy
    End Sub
End Class
